Index: stable/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs	(revision 17122)
+++ stable/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs	(revision 17124)
@@ -20,5 +20,4 @@
 #endregion
 
-using System.Security.AccessControl;
 using System.Windows.Forms;
 
@@ -154,4 +153,9 @@
       this.itemsListView.DoubleClick += new System.EventHandler(this.itemsListView_DoubleClick);
       this.itemsListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyDown);
+      this.itemsListView.Layout += new System.Windows.Forms.LayoutEventHandler(this.itemsListView_Layout);
+      //
+      // listViewColumnHeader
+      //
+      this.listViewColumnHeader.Width = 190;
       // 
       // imageList
Index: stable/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 17122)
+++ stable/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 17124)
@@ -237,5 +237,4 @@
                                (Content != null) && !Content.IsReadOnly && !ReadOnly;
       removeButton.Enabled = itemsListView.SelectedItems.Count > 0 && (Content != null) && !Content.IsReadOnly && !ReadOnly;
-      AdjustListViewColumnSizes();
 
       if (showDetailsCheckBox.Checked) {
@@ -330,4 +329,8 @@
       }
     }
+    protected virtual void itemsListView_Layout(object sender, LayoutEventArgs e) {
+      if (itemsListView.Columns.Count == 1)
+        AdjustListViewColumnSizes();
+    }
     #endregion
 
@@ -453,5 +456,6 @@
         foreach (ListViewItem listViewItem in GetListViewItemsForItem(item))
           UpdateListViewItemText(listViewItem);
-        AdjustListViewColumnSizes();
+        if (itemsListView.Columns.Count > 1)
+          AdjustListViewColumnSizes();
       }
     }
@@ -460,7 +464,12 @@
     #region Helpers
     protected virtual void AdjustListViewColumnSizes() {
-      if (itemsListView.Items.Count > 0) {
-        for (int i = 0; i < itemsListView.Columns.Count; i++)
-          itemsListView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+      if (itemsListView.Columns.Count == 1) {
+        if (itemsListView.Columns[0].Width != itemsListView.ClientSize.Width)
+          itemsListView.Columns[0].Width = itemsListView.ClientSize.Width;
+      } else {
+        if (itemsListView.Items.Count > 0) {
+          for (int i = 0; i < itemsListView.Columns.Count; i++)
+            itemsListView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        }
       }
     }
Index: stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs	(revision 17122)
+++ stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs	(revision 17124)
@@ -20,5 +20,4 @@
 #endregion
 
-using System.Security.AccessControl;
 using System.Windows.Forms;
 
@@ -107,4 +106,9 @@
       this.itemsListView.DoubleClick += new System.EventHandler(this.itemsListView_DoubleClick);
       this.itemsListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyDown);
+      this.itemsListView.Layout += new System.Windows.Forms.LayoutEventHandler(this.itemsListView_Layout);
+      // 
+      // columnHeader1
+      // 
+      this.columnHeader1.Width = 240;
       // 
       // imageList
Index: stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 17122)
+++ stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 17124)
@@ -104,8 +104,7 @@
       if (Content != null) {
         Caption += " (" + Content.GetType().Name + ")";
-        foreach (T item in Content)
+        foreach (T item in Content.OrderBy(x => x.ToString()))
           AddListViewItem(CreateListViewItem(item));
         AdjustListViewColumnSizes();
-        SortItemsListView(SortOrder.Ascending);
       }
     }
@@ -221,5 +220,4 @@
     protected virtual void itemsListView_SelectedIndexChanged(object sender, EventArgs e) {
       removeButton.Enabled = (Content != null) && !Content.IsReadOnly && !ReadOnly && itemsListView.SelectedItems.Count > 0;
-      AdjustListViewColumnSizes();
       if (showDetailsCheckBox.Checked) {
         if (itemsListView.SelectedItems.Count == 1) {
@@ -327,4 +325,8 @@
       }
     }
+    protected virtual void itemsListView_Layout(object sender, LayoutEventArgs e) {
+      if (itemsListView.Columns.Count == 1)
+        AdjustListViewColumnSizes();
+    }
     #endregion
 
@@ -423,5 +425,6 @@
         foreach (ListViewItem listViewItem in GetListViewItemsForItem(item))
           UpdateListViewItemText(listViewItem);
-        AdjustListViewColumnSizes();
+        if (itemsListView.Columns.Count > 1)
+          AdjustListViewColumnSizes();
       }
     }
@@ -435,7 +438,12 @@
     }
     protected virtual void AdjustListViewColumnSizes() {
-      if (itemsListView.Items.Count > 0) {
-        for (int i = 0; i < itemsListView.Columns.Count; i++)
-          itemsListView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+      if (itemsListView.Columns.Count == 1) {
+        if (itemsListView.Columns[0].Width != itemsListView.ClientSize.Width)
+          itemsListView.Columns[0].Width = itemsListView.ClientSize.Width;
+      } else {
+        if (itemsListView.Items.Count > 0) {
+          for (int i = 0; i < itemsListView.Columns.Count; i++)
+            itemsListView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        }
       }
     }
Index: stable/HeuristicLab.Core.Views/3.3/ItemListView.Designer.cs
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/ItemListView.Designer.cs	(revision 17122)
+++ stable/HeuristicLab.Core.Views/3.3/ItemListView.Designer.cs	(revision 17124)
@@ -155,4 +155,9 @@
       this.itemsListView.DoubleClick += new System.EventHandler(this.itemsListView_DoubleClick);
       this.itemsListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyDown);
+      this.itemsListView.Layout += new System.Windows.Forms.LayoutEventHandler(this.itemsListView_Layout);
+      // 
+      // listViewColumnHeader
+      // 
+      this.listViewColumnHeader.Width = 190;
       // 
       // imageList
Index: stable/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 17122)
+++ stable/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 17124)
@@ -242,6 +242,5 @@
       removeButton.Enabled = itemsListView.SelectedItems.Count > 0 &&
                              (Content != null) && !Content.IsReadOnly && !ReadOnly;
-      AdjustListViewColumnSizes();
-
+      
       if (showDetailsCheckBox.Checked) {
         if (itemsListView.SelectedItems.Count == 1) {
@@ -354,4 +353,8 @@
       }
     }
+    protected virtual void itemsListView_Layout(object sender, LayoutEventArgs e) {
+      if (itemsListView.Columns.Count == 1)
+        AdjustListViewColumnSizes();
+    }
     #endregion
 
@@ -494,5 +497,6 @@
         foreach (ListViewItem listViewItem in GetListViewItemsForItem(item))
           UpdateListViewItemText(listViewItem);
-        AdjustListViewColumnSizes();
+        if (itemsListView.Columns.Count > 1)
+          AdjustListViewColumnSizes();
       }
     }
@@ -501,7 +505,12 @@
     #region Helpers
     protected virtual void AdjustListViewColumnSizes() {
-      if (itemsListView.Items.Count > 0) {
-        for (int i = 0; i < itemsListView.Columns.Count; i++)
-          itemsListView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+      if (itemsListView.Columns.Count == 1) {
+        if (itemsListView.Columns[0].Width != itemsListView.ClientSize.Width)
+          itemsListView.Columns[0].Width = itemsListView.ClientSize.Width;
+      } else {
+        if (itemsListView.Items.Count > 0) {
+          for (int i = 0; i < itemsListView.Columns.Count; i++)
+            itemsListView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        }
       }
     }